#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <syslog.h>
#include <errno.h>
#include <pwd.h>
#include <limits.h>
#include <signal.h>

#include <locale.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

# include <grp.h>
# include <pwd.h>


#define LOCAL_SERVER_PORT 514
#define MAX_MSG 2048
#define USERNAME "daemon"
/* make sure PID_FILE_PATH excists, chown it the right user and chmod 755 */
#define PID_FILE_PATH "/var/run/packrat"
#define PID_FILENAME "packrat.pid"
#define PID_FILE "/var/run/packrat/packrat.pid"

/* Common stuff */
#define CRLF            "\r\n"
#define EMPTY           ""
#define PARENT          ".."
#define ROOT            "/"

#define FALSE           0
#define TRUE            1

#define QUIT            1
#define OK              0
#define ERROR           -1

#define MATCH           0

/* Charsets */
#define AUTO            0
#define US_ASCII        1
#define ISO_8859_1      2
#define UTF_8           3

#define UNITS           "KB", "MB", "GB", "TB", "PB", NULL

/* ISO-8859-1 to US-ASCII look-alike conversion table */
#define ASCII \
        "E?,f..++^%S<??Z?" \
        "?''\"\"*--~?s>??zY" \
        " !c_*Y|$\"C?<?-R-" \
        "??23'u?*,1?>????" \
        "AAAAAAACEEEEIIII" \
        "DNOOOOO*OUUUUYTB" \
        "aaaaaaaceeeeiiii" \
        "dnooooo/ouuuuyty"

#define UNKNOWN '?'


/* Struct for keeping the current options & state */
typedef struct {

	/* Settings */
	char log_file[256];
	char username[256];
    char server[64];
} state;

/*
 * Useful macros
 */
#define strclear(str) str[0] = '\0';
#define sstrlcpy(dest, src) strlcpy(dest, src, sizeof(dest))
#define sstrlcat(dest, src) strlcat(dest, src, sizeof(dest))
#define sstrncmp(s1, s2) strncmp(s1, s2, sizeof(s2) - 1)
#define sstrncasecmp(s1, s2) strncasecmp(s1, s2, sizeof(s2) - 1)
#define sstrniconv(charset, out, in) strniconv(charset, out, in, sizeof(out))
#define max(a,b) (((a) > (b)) ? (a) : (b))
#define min(a,b) (((a) < (b)) ? (a) : (b))
#define incopy(a)       *((struct in_addr *)a)
 /*
  * Include generated headers
  */
 #include "functions.h"

